#include "elapsedMillis.h"

typedef union
{
  float number;
  uint8_t bytes[4];
} floatUnion;

#define PINOUT 36
String s1, s2;
floatUnion prezzo;
byte ID;
int i, j;
elapsedMillis timeElapsed, bitElapsed;
int Periodo_FSK = 8;
int Periodo_Zero = 4;
int Periodo_Uno = 2;
  
void setup() {
  
  pinMode(PINOUT,OUTPUT);
  Serial.begin(9600);
  while (!Serial) {
  };

}

void loop() {

  digitalWrite(PINOUT,HIGH);
  
  if (Serial.available() > 0)
  {
    while (Serial.available() > 0)
    {
      s1 = Serial.readStringUntil('\n');
      s2 = Serial.readStringUntil('\n');
    }

    prezzo.number = s1.toFloat();
    ID = s2.toInt(); 
     
//------------------------------------- Header ----------------------------------------------------------//
    Serial.println("INIZIO TRASMISSIONE");
    
    for(i = 0; i < 56; i++)
    { 
      //azzero contatore
      timeElapsed = 0;                
      if((i%2) == 0)                          // posizione bit pari => 0
      {
        while(timeElapsed < Periodo_FSK)      //output onda quadra 250 Hz per 8 ms
        {
          bitElapsed = 0;
          digitalWrite(PINOUT,HIGH);
          while(bitElapsed < Periodo_Zero/2);
          bitElapsed = 0;
          digitalWrite(PINOUT,LOW);
          while(bitElapsed < Periodo_Zero/2);
        }
      }
      else                                    // altrimenti => 1
      {
        while(timeElapsed < Periodo_FSK)      //output onda quadra 500 Hz per 8 ms
        {
          bitElapsed = 0;
          digitalWrite(PINOUT,HIGH);
          while(bitElapsed < Periodo_Uno/2);
          bitElapsed = 0;
          digitalWrite(PINOUT,LOW);
          while(bitElapsed < Periodo_Uno/2);
        }
      }
    }
//------------------------------------ ID -----------------------------------------------------------//
    delay(5);
    
    for (i = 7; i >= 0; i--)
    {
      //azzero contatore
      timeElapsed = 0;
      if(bitRead(ID, i) == 0)
      {
        while(timeElapsed < Periodo_FSK)      //output onda quadra 250 Hz per 8 ms
        {
          bitElapsed = 0;
          digitalWrite(PINOUT,HIGH);
          while(bitElapsed < Periodo_Zero/2);
          bitElapsed = 0;
          digitalWrite(PINOUT,LOW);
          while(bitElapsed < Periodo_Zero/2);
        }
      }
      else                                    // altrimenti => 1
      {
        while(timeElapsed < Periodo_FSK)      //output onda quadra 500 Hz per 8 ms
        {
          bitElapsed = 0;
          digitalWrite(PINOUT,HIGH);
          while(bitElapsed < Periodo_Uno/2);
          bitElapsed = 0;
          digitalWrite(PINOUT,LOW);
          while(bitElapsed < Periodo_Uno/2);
        }
      }
    }
//---------------------------------- Prezzo -------------------------------------------------------------//
    delay(5);
    
    for (i = 3; i >= 0; i--)
    {
      for (j = 7; j >= 0; j--)
      {
        //azzero contatore
        timeElapsed = 0;
        if(bitRead(prezzo.bytes[i], j) == 0)
        {
            while(timeElapsed < Periodo_FSK)       //output onda quadra 250 Hz per 8 ms
            {
              bitElapsed = 0;
              digitalWrite(PINOUT,HIGH);
              while(bitElapsed < Periodo_Zero/2);
              bitElapsed = 0;
              digitalWrite(PINOUT,LOW);
              while(bitElapsed < Periodo_Zero/2);
            }
        }
        else                                      // altrimenti => 1
        {
          while(timeElapsed < Periodo_FSK)        //output onda quadra 500 Hz per 8 ms
          {
            bitElapsed = 0;
            digitalWrite(PINOUT,HIGH);
            while(bitElapsed < Periodo_Uno/2);
            bitElapsed = 0;
            digitalWrite(PINOUT,LOW);
            while(bitElapsed < Periodo_Uno/2);
          }
        }
      }
    }
    Serial.println("FINE TRASMISSIONE"); 
  }
}
